/***************************************************************************
                          objects.c  -  description
                             -------------------
    begin                : Sat Apr 5 2003
    copyright            : (C) 2003 by Steven Goodwin
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <malloc.h>
#include <string.h>
#include <stdlib.h>
#include "explore.h"
#include "objects.h"
#include "render.h"

EX_OBJECT *exCreateObject(int x, int y, int speed, int type)
{
EX_OBJECT *pObj;

	/* Initialise a basic object */
	pObj = (EX_OBJECT *)malloc(sizeof(EX_OBJECT));
	if (!pObj)
		return NULL;
	pObj->x = x;
	pObj->y = y;

      pObj->iDirection = 1;
      pObj->iSpeed = speed;
	pObj->iAnimFrame = 0;
	pObj->iGraphicType = type;

	/* Update linked list */
	pObj->pNext = TheGame.curr_level.pObjList;
	TheGame.curr_level.pObjList = pObj;

return pObj;	
}

void exUpdateObject(EX_OBJECT *pObj)
{
	/* Animate */
	if (++pObj->iAnimFrame == 8)
		pObj->iAnimFrame = 0;

	/* Move */
	pObj->x += pObj->iDirection * pObj->iSpeed;
	if ((rand() & 15) == 0)
		pObj->iDirection = -pObj->iDirection;
}

void exDrawObject(EX_OBJECT *pObj)
{
	exDrawTile(TheGame.pGeneralEnemyGfx, pObj->iGraphicType+pObj->iAnimFrame/2, pObj->x, pObj->y);
}

EX_OBJECT *exDestroyObject(EX_OBJECT *pObj)
{
EX_OBJECT *pNext = pObj->pNext;

	free(pObj);
	return pNext;
}
